package cn.com.infosec.asn1.esf;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;

public class OtherHashAlgAndValue extends ASN1Encodable {
   private AlgorithmIdentifier hashAlgorithm;
   private ASN1OctetString hashValue;

   public static OtherHashAlgAndValue getInstance(Object obj) {
      if (obj != null && !(obj instanceof OtherHashAlgAndValue)) {
         if (obj instanceof ASN1Sequence) {
            return new OtherHashAlgAndValue((ASN1Sequence)obj);
         } else {
            throw new IllegalArgumentException("unknown object in 'OtherHashAlgAndValue' factory : " + obj.getClass().getName() + ".");
         }
      } else {
         return (OtherHashAlgAndValue)obj;
      }
   }

   public OtherHashAlgAndValue(ASN1Sequence seq) {
      if (seq.size() == 2) {
         this.hashAlgorithm = AlgorithmIdentifier.getInstance(seq.getObjectAt(0));
         this.hashValue = ASN1OctetString.getInstance(seq.getObjectAt(1));
      } else {
         throw new IllegalArgumentException("Bad sequence size: " + seq.size());
      }
   }

   public OtherHashAlgAndValue(AlgorithmIdentifier hashAlgorithm, ASN1OctetString hashValue) {
      this.hashAlgorithm = hashAlgorithm;
      this.hashValue = hashValue;
   }

   public AlgorithmIdentifier getHashAlgorithm() {
      return this.hashAlgorithm;
   }

   public ASN1OctetString getHashValue() {
      return this.hashValue;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.hashAlgorithm);
      var10000.add(this.hashValue);
      return new DERSequence(var1);
   }
}
